// Hyper Form (Alt Ver.) by Sls64LGamingBro \\

   -----------------------------

// This is used for when in Sonic 3 & Knuckles. Sonic turn Hyper, \\

   -----------------------------

// But it's the alternative version, since it just drops in a 2nd form. \\

   -----------------------------
  
// It'll not replace the Super Form, anyway, let's get into the script! \\

   -----------------------------


// Main \\


COM_AddCommand("altcancel", function(p, arg)
	if arg == "custom1" or arg == "c1" then
		p.custom1 = 1
		p.custom2 = 0
		p.custom3 = 0
		p.tossflag = 0
		p.firenormal = 0
		CONS_Printf(p, "Custom 1 is your cancel button!")
	elseif arg == "custom2" or arg == "c2" then
		p.custom2 = 1
		p.custom1 = 0
		p.custom3 = 0
		p.tossflag = 0
		p.firenormal = 0
		CONS_Printf(p, "Custom 2 is your cancel button!")
	elseif arg == "custom3" or arg == "c3" then
		p.custom3 = 1
		p.custom1 = 0
		p.custom2 = 0
		p.tossflag = 0
		p.firenormal = 0
		CONS_Printf(p, "Custom 3 is your cancel button!")
	elseif arg == "tossflag" then
		p.tossflag = 1
		p.custom1 = 0
		p.custom2 = 0
		p.custom3 = 0
		p.firenormal = 0
		CONS_Printf(p, "Tossflag is your cancel button!")
	elseif arg == "firenormal" then
		p.firenormal = 1
		p.custom1 = 0
		p.custom2 = 0
		p.custom3 = 0
		p.tossflag = 0
		CONS_Printf(p, "FireNormal is your cancel button!")
	elseif arg == "off" then
		p.custom1 = 0
		p.custom2 = 0
		p.custom3 = 0
		p.tossflag = 0
		p.firenormal = 0
		CONS_Printf(p, "There is no cancel button added")
	end
end, COM_ADMIN)


addHook("PlayerThink", function(player)
	if player.mo.skin == "sonic"
		if not (player.mo.hyperform) then
	       player.mo.hyperform = 0
	    end
		
		if (player.cmd.buttons & BT_SPIN)
		and (player.pflags & PF_JUMPED)
		and (player.powers[pw_super])
		and not (player.powers[pw_carry])
		and not (player.mo.state == S_PLAY_SUPER_TRANS1)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS2)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS3)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS4)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS5)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS6)
		and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT) 
		and player.mo.hyperform == 0
		and (player.rings >= 100)
		    P_DoSuperTransformation(player, true)
			S_StartSound(player.mo, sfx_s3k9f)
	        player.mo.hyperform = 1
			player.hypertrans = true
	    end
    end  
end)


addHook("PlayerThink", do
    for player in players.iterate
	    if (player.cmd.buttons & BT_CUSTOM1)
		and player.custom1 == 1
		and player.mo.skin == "sonic"
		and (player.pflags & PF_JUMPED)
		and not (player.powers[pw_carry])
		and not (player.mo.state == S_PLAY_SUPER_TRANS1)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS2)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS3)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS4)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS5)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS6)
		and (player.powers[pw_super])
		   player.powers[pw_super] = 0
		   P_RestoreMusic(player)
		   P_SpawnShieldOrb(player)
		   P_SpawnGhostMobj(player.mo)
		   player.mo.color = player.skincolor
		end
	end
end)


addHook("PlayerThink", do
    for player in players.iterate
	    if (player.cmd.buttons & BT_CUSTOM2)
		and player.custom2 == 1
		and player.mo.skin == "sonic"
		and (player.pflags & PF_JUMPED)
		and not (player.powers[pw_carry])
		and not (player.mo.state == S_PLAY_SUPER_TRANS1)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS2)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS3)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS4)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS5)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS6)
		and (player.powers[pw_super])
		   player.powers[pw_super] = 0
		   P_RestoreMusic(player)
		   P_SpawnShieldOrb(player)
		   P_SpawnGhostMobj(player.mo)
		   player.mo.color = player.skincolor
		end
	end
end)


addHook("PlayerThink", do
    for player in players.iterate
	    if (player.cmd.buttons & BT_CUSTOM3)
		and player.custom3 == 1
		and player.mo.skin == "sonic"
		and (player.pflags & PF_JUMPED)
		and not (player.powers[pw_carry])
		and not (player.mo.state == S_PLAY_SUPER_TRANS1)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS2)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS3)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS4)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS5)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS6)
		and (player.powers[pw_super])
		   player.powers[pw_super] = 0
		   P_RestoreMusic(player)
		   P_SpawnShieldOrb(player)
		   P_SpawnGhostMobj(player.mo)
		   player.mo.color = player.skincolor
		end
	end
end)


addHook("PlayerThink", do
    for player in players.iterate
	    if (player.cmd.buttons & BT_TOSSFLAG)
		and player.tossflag == 1
		and player.mo.skin == "sonic"
		and (player.pflags & PF_JUMPED)
		and not (player.powers[pw_carry])
		and not (player.mo.state == S_PLAY_SUPER_TRANS1)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS2)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS3)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS4)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS5)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS6)
		and (player.powers[pw_super])
		   player.powers[pw_super] = 0
		   P_RestoreMusic(player)
		   P_SpawnShieldOrb(player)
		   P_SpawnGhostMobj(player.mo)
		   player.mo.color = player.skincolor
		end
	end
end)


addHook("PlayerThink", do
    for player in players.iterate
	    if (player.cmd.buttons & BT_FIRENORMAL)
		and player.firenormal == 1
		and player.mo.skin == "sonic"
		and (player.pflags & PF_JUMPED)
		and not (player.powers[pw_carry])
		and not (player.mo.state == S_PLAY_SUPER_TRANS1)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS2)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS3)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS4)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS5)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS6)
		and (player.powers[pw_super])
		   player.powers[pw_super] = 0
		   P_RestoreMusic(player)
		   P_SpawnShieldOrb(player)
		   P_SpawnGhostMobj(player.mo)
		   player.mo.color = player.skincolor
		end
	end
end)


addHook("PlayerThink", function(player)
	if (player.mo.skin == "sonic")
	    if (player.speed >= FixedMul(player.runspeed, player.mo.scale))
	    and player.mo.hyperform
           local hypertrail = P_SpawnGhostMobj(player.mo)
	       hypertrail.color = (SKINCOLOR_HYPER1 + abs(((player.powers[pw_super] >> 2) % 9) - 6))
           hypertrail.fuse = 4
	       hypertrail.rollangle = player.mo.rollangle
		end   
	end
end)


addHook("AbilitySpecial", function(player)
	if (player.mo.skin == "sonic")
	and player.mo.hyperform == 1
	and not (player.pflags & PF_THOKKED)
		P_NukeEnemies(player.mo, player.mo, 1000*FRACUNIT)
		S_StartSound(player.mo, sfx_s3kb6)
		P_FlashPal(player, PAL_WHITE, 5)
		P_Thrust(player.mo, player.mo.angle, 25*FRACUNIT)
		player.pflags = $|PF_THOKKED 
	end
end)


addHook("ThinkFrame", do
	for player in players.iterate
		if (player.mo and player.mo.valid and player.mo.skin == "sonic")
			if not player.powers[pw_extralife]
			and not (player.exiting)
			if player.powers[pw_super] and player.mo.hyperform then
				S_ChangeMusic("_HYPER",true,player)
			end	
		else
			P_RestoreMusic(player)
			end
		end
	end
end)

// Others \\


addHook("PlayerThink", function(player)
    if player.mo.hyperform
		player.powers[pw_underwater] = 100*TICRATE
		player.powers[pw_spacetime] = 100*TICRATE
	 end
end)


addHook('PlayerThink', do
	for player in players.iterate
	    if player.mo and player.mo.valid
			if player.powers[pw_super] == 0
			 player.mo.hyperform = 0
			 P_RestoreMusic(player)
		     player.mo.color = player.skincolor
		     player.normalspeed = skins[player.mo.skin].normalspeed
		 end
	 end 
end
end)


addHook("PlayerThink", function(player)
	if leveltime % 4 == 0 then
		if player.mo.hyperform
		and player.mo.skin == "sonic"
			local strikesparkle = P_SpawnMobj(player.mo.x+(P_RandomRange(16,-16)*FRACUNIT),player.mo.y+(P_RandomRange(16,-16)*FRACUNIT),player.mo.z+(player.mo.height/2)+(P_RandomRange(8,-8)*FRACUNIT),MT_SUPERSPARK)
			strikesparkle.color = SKINCOLOR_GREY
			strikesparkle.colorized = true
			strikesparkle.scale = player.mo.scale * 3 / 2
			strikesparkle.momx = P_RandomRange(5,-5)*FRACUNIT
			strikesparkle.momy = P_RandomRange(5,-5)*FRACUNIT
			strikesparkle.momz = P_RandomRange(5,-5)*FRACUNIT
	     end
	 end
end)


addHook("PlayerThink", function(player)
    if player.mo.skin == "sonic"
	    if player.hypertrans
		and player.mo.hyperform == 1
		and not (player.mo.state == S_PLAY_SUPER_TRANS1)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS2)
	    and not (player.mo.state == S_PLAY_SUPER_TRANS3)
			player.mo.color = (SKINCOLOR_HYPER1 + abs(((player.powers[pw_super] >> 2) % 9) - 6))
		end
	end
end)


addHook("PlayerThink", function(player)
	if (player.mo.hyperform == 1) then
	    if (skins[player.mo.skin])
		  and not (player.mo.skin == "sonic") then
			player.mo.hyperform = 0
		end
	end
end)


// Colors \\


// Hyper colors. 


// Red Starts

freeslot("SKINCOLOR_HYPER1")
skincolors[SKINCOLOR_HYPER1] = {
	name = "Hyper 1",
	ramp = {0,0,0,0,0,0,0,0,209,209,210,210,32,32,33,33},
	invcolor = SKINCOLOR_ORANGE,
	invshade = 9,
	chatcolor = V_BLUEMAP,
	accessible = false
}

// Blue

freeslot("SKINCOLOR_HYPER2")
skincolors[SKINCOLOR_HYPER2] = {
	name = "Hyper 2",
	ramp = {0,0,0,0,0,0,0,0,129,129,130,130,131,131,132,132},
	invcolor = SKINCOLOR_ORANGE,
	invshade = 9,
	chatcolor = V_BLUEMAP,
	accessible = false
}

// Green

freeslot("SKINCOLOR_HYPER3")
skincolors[SKINCOLOR_HYPER3] = {
	name = "Hyper 3",
	ramp = {0,0,0,0,0,0,0,0,98,98,99,99,100,100,101,101},
	invcolor = SKINCOLOR_ORANGE,
	invshade = 9,
	chatcolor = V_BLUEMAP,
	accessible = false
}

// Yellow

freeslot("SKINCOLOR_HYPER4")
skincolors[SKINCOLOR_HYPER4] = {
	name = "Hyper 4",
	ramp = {0,0,0,0,0,0,0,0,82,82,83,83,72,72,74,74},
	invcolor = SKINCOLOR_ORANGE,
	invshade = 9,
	chatcolor = V_BLUEMAP,
	accessible = false
}

// White

freeslot("SKINCOLOR_HYPER5")
skincolors[SKINCOLOR_HYPER5] = {
	name = "Hyper 5",
	ramp = {0,0,0,0,0,0,0,0,1,1,2,2,3,3,4,4},
	invcolor = SKINCOLOR_ORANGE,
	invshade = 9,
	chatcolor = V_BLUEMAP,
	accessible = false
}

// Violet

freeslot("SKINCOLOR_HYPER6")
skincolors[SKINCOLOR_HYPER6] = {
	name = "Hyper 6",
	ramp = {0,0,0,0,0,0,0,0,160,160,161,161,162,162,163,163},
	invcolor = SKINCOLOR_ORANGE,
	invshade = 9,
	chatcolor = V_BLUEMAP,
	accessible = false
}

// Red ending

freeslot("SKINCOLOR_HYPER7")
skincolors[SKINCOLOR_HYPER7] = {
	name = "Hyper 7",
	ramp = {0,0,0,0,0,0,0,0,200,200,201,201,202,202,203,203},
	invcolor = SKINCOLOR_ORANGE,
	invshade = 9,
	chatcolor = V_BLUEMAP,
	accessible = false
}